/*
  tractorrequired.c - "Your ship must have a mounted tractor beam to launch."

  Jason Hood, 12 August, 2010.

  Uses the "Tractor failure" message.

  Build (VC 6):
	rc tractorrequired.rc
	cl /nologo /W3 /GfX /Ox /MD /LD tractorrequired.c tractorrequired.res

  Install:
    copy TRACTORREQUIRED.DLL to the EXE directory and add it to the [Libraries]
    section of EXE\dacom.ini.

  v1.01, 3 May, 2011:
  - change protection at ADDR_RSRC.
*/

#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#define NAKED	__declspec(naked)


#define ADDR_CHECK ((PBYTE)0x442323)
#define ADDR_TEST  ((PBYTE)0x442412+2)
#define ADDR_RSRC  ((PDWORD)(0x5b1caa+1))


DWORD dummy;
#define ProtectX( addr, size ) \
  VirtualProtect( addr, size, PAGE_EXECUTE_READWRITE, &dummy );

#define RELOFS( from, to ) \
  *(PDWORD)(from) = (DWORD)(to) - (DWORD)(from) - 4;

#define JMP( from, to ) \
  *(PBYTE)(from) = 0xe9; \
  RELOFS( (DWORD)from+1, to )


HMODULE g_hinst;
UINT	rsrcid;
DWORD	old_resource;


NAKED
void Check_Hook( void )
{
  __asm {
	sub	eax, 8
	jz	scanner
	dec	eax
	dec	eax
	jnz	done
	or	byte ptr [esp+0x0F], 2
  done:
	push	0x442338
	ret
  scanner:
	push	0x442328
	ret
  }
}


NAKED
void Test_Hook( void )
{
  __asm {
	cmp	cl, 1
	je	no_tractor
	cmp	cl, 2
	je	no_scanner
	push	0x442499
	ret
  no_scanner:
	push	0x442418
	ret
  no_tractor:
	mov	eax, 0x489e80
	push	0
	push	0x9c9dbac2	// nnv_tractor_failure
	call	eax
	push	0x41000000	// 8.0f
	push	rsrcid
	push	0x44242f
	ret
  }
}


NAKED
void Resource_Hook( void )
{
  __asm push	[esp+4]
  __asm call	old_resource
  __asm add	esp, 4

  __asm mov	eax, ds:[0x67c404]	// get the number of our resource
  __asm sub	eax, ds:[0x67c400]
  __asm shl	eax, 14
  __asm mov	rsrcid, eax
  __asm mov	eax, 0x57d800
  __asm push	g_hinst
  __asm call	eax
  __asm add	esp, 4
  __asm ret
}


void Patch()
{
  ProtectX( ADDR_CHECK, 5 );
  //ProtectX( ADDR_TEST, 4 );
  ProtectX( ADDR_RSRC, 4 );

  // Check for the tractor beam's hp_type.
  JMP( ADDR_CHECK, Check_Hook );

  // Test if the tractor beam is mounted.
  RELOFS( ADDR_TEST, Test_Hook );

  // Hook in code to load ourself as a resource DLL.
  old_resource = *ADDR_RSRC + (DWORD)ADDR_RSRC + 4;
  RELOFS( ADDR_RSRC, Resource_Hook );
}


BOOL WINAPI DllMain( HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved )
{
  if (fdwReason == DLL_PROCESS_ATTACH)
  {
    g_hinst = hinstDLL;
    Patch();
  }

  return TRUE;
}
